<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="//cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
  <script src="//cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F100 - Quản trị Người Dùng</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Role</label>
        </div>
        <div class="col-sm-6">
          <select id="gUserSelect" class="form-control">
  
          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-user" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
  </div>

  <div class="container">
    <table class="table table-bordered table-striped table-hover" id="user-table">
      <thead>
        <tr>
          <th>STT</th>
          <th>User Name</th>
          <th>First Name</th>
          <th>Last Name</th>
          <th>Email</th>
          <th>Age</th>
          <th>Role</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>
  </div>


<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin" 
        },
        {
          roleId: 8,
          roleName: "Manager" 
        },
        {
          roleId: 11,
          roleName: "Teacher" 
        },
        {
          roleId: 13,
          roleName: "Staff" 
        }
  ];
  const ARR_NAME_COL = ['id', 'username', 'firstname', 'lastname', 'age', 'email', 'roleId', 'action'];
  const COL_ID = 0;
  const COL_USER_NAME = 1;
  const COL_FIRST_NAME = 2;
  const COL_LAST_NAME = 3;
  const COL_AGE = 4;
  const COL_EMAIL = 5;
  const COL_ROLE_ID = 6;
  const COL_ACTION = 7;

  var gSTT = 1;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  //gán sự kiện nút lọc dữ liệu
  $("#btn-filter-user").on("click", function(){
    onBtnFilterDataClick();
  })
  //gán sự kiện cho nút dice
  $(document).on("click","#user-table .fa-dice" ,function() {
    onBtnDiceHistoryClick(this)
  });
  //gán sự kiện nút vouhcer history
  $(document).on('click', "#user-table .fa-gift", function(){
    onBtnVoucherClick(this);
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  function onPageLoading(){
    $('#user-table').DataTable({
        data: gUserObjects,
        columns: [
            { data: ARR_NAME_COL[COL_ID]},
            { data: ARR_NAME_COL[COL_USER_NAME] },
            { data: ARR_NAME_COL[COL_FIRST_NAME] },
            { data: ARR_NAME_COL[COL_LAST_NAME]},
            { data: ARR_NAME_COL[COL_AGE]},
            { data: ARR_NAME_COL[COL_EMAIL]},
            { data: ARR_NAME_COL[COL_ROLE_ID]},
            { data: ARR_NAME_COL[COL_ACTION]},
        ],
        columnDefs: [ //định nghĩa lại cột
          {
            targets: COL_ID,
            render: function(data){
              return gSTT++;
            }
          },
          {
            targets: COL_ACTION,
            defaultContent: `<i class="fas fa-dice fa-2x" title="dice" style="cursor: pointer; color: green"></i> &nbsp; 
            <i class="fas fa-gift fa-2x" title="voucher" style="cursor: pointer; color: green"></i>`
          }
        ],
    });
    loadDataToSelect(gRoleObjects);
  }
  //hàm thực hiện sự kiện nút dice được click
  function onBtnDiceHistoryClick(paramData) {
    var vTable = $('#user-table').DataTable();
    var vTableRow = $(paramData).parents('tr');
		var vUserRowData = vTable.row(vTableRow).data();

    var vFirstname = vUserRowData.firstname;
    var vLastname = vUserRowData.lastname;
    var vUsername =  vUserRowData.username;

    window.location.href = "diceHistory.html" + "?firstname=" + vFirstname + "&username=" + vUsername + "&lastname=" + vLastname;
  }
  // hàm thực hiện sự kiện nút voucher click
  function onBtnVoucherClick(paramData){
    console.log("nút được ấn");
    var vTable = $("#user-table").DataTable(); //truy xuất dataTable
    var vTableRow = $(paramData).parents('tr') //tìm đến dòng được ấn nút voucher
    var vUserRowData = vTable.row(vTableRow).data() //lấy dữ liệu ở dòng đó lưu vào biến vUserRowData

    var vUserName = vUserRowData.username;
    var vFirstName = vUserRowData.firstname;
    var vLastName = vUserRowData.lastname;
    console.log(vUserName);
    console.log(vFirstName);
    console.log(vLastName);
    window.location.href = "voucherHistory.html" + "?firstname=" + vFirstName + "&username=" + vUserName + "&lastname=" + vLastName;
  }
  //hàm xử lý sự kiện nút lọc dữ liệu được click
  function onBtnFilterDataClick(){
    console.log("nút đươc ấn");
    //tạo đối tượng chứa data điều kiện lọc
    var vFilter = {
      role: 0,
    }
    //b1 thu thập dữ liệu
    getDataFormSelect(vFilter);
    //b2 kiểm tra dữ liệu

    //b3 lọc dữ liệu
    var vResultFilter = filterData(vFilter)
    console.log(vResultFilter);
    //b4 xử lý hiển thị
    displayDataToTable(vResultFilter);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm hiển thị dữ liệu lọc lên data table
  //input dữ liệu cần hiển thị
  function displayDataToTable(paramData){
    "use strict";
    gSTT = 1; //thiết lập lại số thứ tự
    var vDataTable = $("#user-table").DataTable(); //truy xuất data table
    vDataTable.clear() // xóa dữ liệu của data table
    vDataTable.rows.add(paramData)// thêm các dòng dữ liệu vào dataTable
    vDataTable.draw(); //vẽ lại bảng
  }
  //hàm lọc dữ liệu
  //input là điều kiện lọc
  //output là kết quả điều kiện lọc
  function filterData(paramFilter){
    "use strict";
    var vResault = [];
    vResault = gUserObjects.filter(function(item){
      return (item.roleId == paramFilter.role || paramFilter.role == 0);
    });
    return vResault;
  }
  //hàm thu thập dữ liệu select từ form
  function getDataFormSelect(paramFilter){
    paramFilter.role = $("#gUserSelect").val();
  };
  //hàm load dato Role to select
  function loadDataToSelect(paramRole){
    "use strict";
    $("#gUserSelect").append($("<option>", {
      value: 0,
      text: "--Chọn Role--",
    }));
    for(let bI = 0; bI < paramRole.length; bI++){
      $("#gUserSelect").append($("<option>", {
      value: paramRole[bI].roleId,
      text: paramRole[bI].roleName,
    }));
    }
  }

</script>
</body>
</html>